# Class VolumeData

java.lang.Object
org.jmol.jvxl.data.VolumeData

public class VolumeData extends Object

## Field Summary

Fields
Modifier and Type
Field
Description
`boolean`
`doIterate`
`boolean`
`isPeriodic`
`P4`
`mappingPlane`
`float`
`maxGrid`
`float`
`minGrid`
`int`
`nPoints`
`V3[]`
`oabc`
`final float[]`
`origin`
`SurfaceReader`
`sr`
`final V3[]`
`unitVolumetricVectors`
`final P3`
`volumetricOrigin`
`final float[]`
`volumetricVectorLengths`
`final V3[]`
`volumetricVectors`
`final int[]`
`voxelCounts`
`float`
`voxelVolume`
`String`
`xmlData`

## Constructor Summary

Constructors
Constructor
Description
`VolumeData()`

## Method Summary

Modifier and Type
Method
Description
`float`
`calculateFractionalPoint(float cutoff, P3 pointA, P3 pointB, float valueA, float valueB, P3 pt)`
`float`
`calcVoxelPlaneDistance(int x, int y, int z)`
`void`
`capData(P4 plane, float cutoff)`
`float`
`distancePointToPlane(T3 pt)`
`float`
`distanceToMappingPlane(T3 pt)`
`void`
`filterData(boolean isSquared, float invertCutoff)`
`static float`
`getFractional2DValue(float fx, float fy, float x11, float x12, float x21, float x22)`
`float[]`
`getOriginFloat()`
`void`
`getPoint(int ipt, P3 pt)`
`int`
`getPointIndex(int x, int y, int z)`
`float`
`getToPlaneParameter()`
`float[]`
`getVolumetricVectorLengths()`
`int[]`
`getVoxelCounts()`
`float[][][]`
`getVoxelData()`
`float`
`getVoxelDataAt(int pt)`
`float`
`getVoxelValue(int x, int y, int z)`
`int`
`getYzCount()`
`boolean`
`hasPlane()`
`boolean`
`isNearPlane(int x, int y, int z, float toPlaneParameter)`
`float`
`lookupInterpolatedVoxelValue(T3 point, boolean getSource)`
`void`
`setDataDistanceToPlane(P4 plane)`
`void`
`setMappingPlane(P4 plane)`
`void`
`setPlaneParameters(P4 plane)`
`boolean`
`setUnitVectors()`
`void`
`setVolumetricOrigin(float x, float y, float z)`
`void`
`setVolumetricVector(int i, float x, float y, float z)`
`String`
`setVolumetricXml()`
`int`
`setVoxelCounts(int nPointsX, int nPointsY, int nPointsZ)`
`void`
`setVoxelData(int pt, float value)`
`void`
`setVoxelDataAsArray(float[][][] voxelData)`
`void`
`setVoxelMap()`
`void`
`setVoxelMapValue(int x, int y, int z, float v)`
for sparse data mapping, as for a plane
`void`
`transform(V3 v1, V3 v2)`
`void`
`voxelPtToXYZ(int x, int y, int z, T3 pt)`
`void`
`xyzToVoxelPt(float x, float y, float z, T3i pt3i)`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### sr

public SurfaceReader sr

### doIterate

public boolean doIterate

### volumetricOrigin

public final P3 volumetricOrigin

### origin

public final float[] origin

### volumetricVectors

public final V3[] volumetricVectors

### voxelCounts

public final int[] voxelCounts

### nPoints

public int nPoints

### volumetricVectorLengths

public final float[] volumetricVectorLengths

### unitVolumetricVectors

public final V3[] unitVolumetricVectors

### xmlData

public String xmlData

### mappingPlane

public P4 mappingPlane

### minGrid

public float minGrid

### maxGrid

public float maxGrid

### voxelVolume

public float voxelVolume

### oabc

public V3[] oabc

### isPeriodic

public boolean isPeriodic

## Constructor Details

### VolumeData

public VolumeData()

## Method Details

### getVoxelData

public float[][][] getVoxelData()

### setVoxelDataAsArray

public void setVoxelDataAsArray(float[][][] voxelData)

### hasPlane

public boolean hasPlane()

### setMappingPlane

public void setMappingPlane(P4 plane)

### distanceToMappingPlane

public float distanceToMappingPlane(T3 pt)

### setVolumetricOrigin

public void setVolumetricOrigin(float x, float y, float z)

### getOriginFloat

public float[] getOriginFloat()

### getYzCount

public int getYzCount()

### getVolumetricVectorLengths

public float[] getVolumetricVectorLengths()

### setVolumetricVector

public void setVolumetricVector(int i, float x, float y, float z)

### getVoxelCounts

public int[] getVoxelCounts()

### setVoxelCounts

public int setVoxelCounts(int nPointsX, int nPointsY, int nPointsZ)

### getVoxelDataAt

public float getVoxelDataAt(int pt)

### getPointIndex

public int getPointIndex(int x, int y, int z)

### getPoint

public void getPoint(int ipt, P3 pt)

### setVoxelData

public void setVoxelData(int pt, float value)

### setVoxelMap

public void setVoxelMap()

### transform

public void transform(V3 v1, V3 v2)

### setPlaneParameters

public void setPlaneParameters(P4 plane)

### calcVoxelPlaneDistance

public float calcVoxelPlaneDistance(int x, int y, int z)

### getToPlaneParameter

public float getToPlaneParameter()

### isNearPlane

public boolean isNearPlane(int x, int y, int z, float toPlaneParameter)

### distancePointToPlane

public float distancePointToPlane(T3 pt)

### voxelPtToXYZ

public void voxelPtToXYZ(int x, int y, int z, T3 pt)

### setUnitVectors

public boolean setUnitVectors()

### xyzToVoxelPt

public void xyzToVoxelPt(float x, float y, float z, T3i pt3i)

### lookupInterpolatedVoxelValue

public float lookupInterpolatedVoxelValue(T3 point, boolean getSource)

### getVoxelValue

public float getVoxelValue(int x, int y, int z)

### getFractional2DValue

public static float getFractional2DValue(float fx, float fy, float x11, float x12, float x21, float x22)

### setDataDistanceToPlane

public void setDataDistanceToPlane(P4 plane)

### filterData

public void filterData(boolean isSquared, float invertCutoff)

### capData

public void capData(P4 plane, float cutoff)

### setVolumetricXml

public String setVolumetricXml()

### setVoxelMapValue

public void setVoxelMapValue(int x, int y, int z, float v)
for sparse data mapping, as for a plane

Parameters:
  `x` -
  `y` -
  `z` -
  `v` -

### calculateFractionalPoint

public float calculateFractionalPoint(float cutoff, P3 pointA, P3 pointB, float valueA, float valueB, P3 pt)